#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;

vector<vector<int>> desk; int ans;
void fill(pair<int, int> left, pair<int, int> right) {
	for (int i = right.second; i < left.second;i++) {
			for (int j = left.first; j < right.first; j++) {
				if (!desk[i][j])ans++;
				desk[i][j] = 1;
			}
		}
}
int main() {

	ios::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	fstream cin("input.txt");
	fstream cout("output.txt");
#endif
	ans = 0;

	int start = 1e5 / 2;
	int k, n; cin >> k >> n;
	desk.resize(1e5, vector<int> (1e5));
	pair<int, int> right = { k+start,start-k };
	pair<int, int> left = { start,start };
	while (n--) {
		char way; cin >> way;
		int dist; cin >> dist;
		pair<int,int> newRight, newLeft;
		if (way == 'N') {
			newRight = { right.first, right.second - dist };
			newLeft = { left.first,left.second };
			left.second = newRight.second + k;
			right = newRight;
		}
		if (way == 'S') {
			newRight = { right.first,right.second };
			newLeft = { left.first,left.second + dist };
			right.second = newLeft.second - k;
			left = newLeft;
		}
		if (way == 'W') {
			newRight = right;
			newLeft = { left.first - dist,left.second };
			left = newLeft;
			right.first = left.first + k;
		}
		if (way == 'E') {
			newLeft = left;
			newRight = {right.first + dist, right.second};
			right = newRight;
			left.first = right.first - k;
		}
		fill(newLeft, newRight);
	}
	
	cout << ans;
}