#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;

vector<int> a;
int n;
const ll INF = 1e9 + 7;

ll fun(vector<int> last, int way) {
	if (way == n) return 1;
	ll ans = 0;
	for (int i = 0; i < a.size(); i++) {
		if (way - last[a[i]] >= a[i]) {
			int ab = last[a[i]];
			last[a[i]] = way;
			ans += fun(last, way + 1)%INF;
			last[a[i]] = ab;
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	cin >> n;
	int m; cin >> m;
	vector<int>last;
	last.resize(9,-100);
	for (int i = 0; i < m; i++) {
		int v; cin >> v;
		a.push_back(v);
	}
	cout << fun(last, 0);
	
}