#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;

const ll INF = 1e9 + 7;
ll total(vector<ll> a) {
	ll ans = 0;
	for (int i = 0; i < a.size(); i++) {
		ans += a[i];
		ans %= INF;
	}return ans;
}
void sdwig(vector<ll>& a) {
	for (int i = 0; i < a.size() - 1; i++) {
		a[i + 1] = a[i];
	}
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	int n, z; cin >> n >> z;
	vector<int> s;

	for (int i = 0; i < z; i++) {
		int v; cin >> v;
		s.push_back(v);
	}
	if ((int)s.size() == 2 && s[0] == 1) {
		vector<ll> dp(n+1);
		int k = s[1];
		vector<ll> zeros(k - 1);
		zeros[0] = 1;
		dp[0] = 2;
		for (int i = 1; i <= n; i++) {
			ll newO = dp[i - 1] - total(zeros)%INF;
			dp[i] = dp[i - 1] + newO;
			dp[i] %= INF;
			sdwig(zeros);
			zeros[0] = newO;
		}
		cout << dp[n-1];
	}
}