#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;

ll check(ll n, ll k) {
	return (n + 1)*(k - n + 1);
}
int main() {

	ios::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	fstream cin("input.txt");
	fstream cout("output.txt");
#endif
	int t; cin >> t;
	while (t--) {
		ll a, b, k, m; cin >> a >> b >> k >> m;
		ll l = -1, r = k,md;
		while (r - l > 1) {
			md = (l + r) / 2;
			if (md >= b)r = md;
			else if (check(md, k) <= check(md + 1, k) && m >= check(md, k))l = md;
			else r = md;
		}
		if (check(r, k) == m && a > k - r && b > r) {
			cout << k - r << " " << r << '\n';
		}
		else {
			cout << -1 << '\n';
		}
	}
	
}