#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;
struct st {
	ll z, a, b;
};

ll fun(vector<st>& a, ll m) {
	ll ans = 0;
	for (int i = 0; i < a.size(); i++) {
		if (m > a[i].z) ans += a[i].a*a[i].z+a[i].b*(m-a[i].z);
		else ans += a[i].a*m;
	}
	return ans;
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	ll n, p; cin >> n >> p;
	vector<st> v;
	for(int i=0;i<n;i++){
		ll z, a, b; cin >> z >> a >> b;
		v.push_back({ z,a,b });
	}
	ll l = 0, r = p, m;
	while (r - l > 1) {
		m = (l + r) / 2;
		if (fun(v, m) >= p)r = m;
		else l = m;
	}
	cout << r;
}