#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <functional>

using namespace std;
typedef long long ll;

const ll INF = 1e9 + 7;
ll total(vector<ll> a) {
	ll ans = 0;
	for (int i = 0; i < a.size(); i++) {
		ans += a[i];
		ans %= INF;
	}return ans;
}
void sdwig(vector<ll>& a) {
	for (int i = a.size() - 1; i > 0; i--) {
		a[i] = a[i - 1];
	}
	a[0] = 0;
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	fstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	int n, z; cin >> n >> z;
	vector<int> s;

	for (int i = 0; i < z; i++) {
		int v; cin >> v;
		s.push_back(v);
	}
	if ((int)s.size() == 2 && s[0] == 1) {
		vector<ll> dp(n + 1);
		ll k = s[1];
		vector<vector<ll>> nums(s.size());
		for (int i = 0; i < s.size(); i++) {
			if (s[i] == 1)continue;
			nums[i].resize(s[i] - 1);
			nums[i][0] = 1;
		}
		
		dp[0] = 2;
		bool flag = true;
		vector<ll> newN(s.size());
		for (int i = 1; i <= n; i++) {
			ll newO = dp[i-1];
			
			for (int i = 0; i < s.size(); i++) {
				if (s[i] == 1)continue;
				newN[i] = total(nums[i]);
				newO = (newO - total(nums[i]) + INF) % INF;
			}
			dp[i] = dp[i - 1] + newO;
			dp[i] %= INF;
			for (int i = 0; i < s.size(); i++) {
				if (s[i] == 1)continue;
				sdwig(nums[i]);
				nums[i][0] = newN[i];
			}
			if (dp[i] == dp[i - 1]) {
				flag = false;
				break;
				
			}
		}
		if(flag)
		cout << dp[n - 1];
		else cout << 0;
	}
}